//==== History ====//
//R00	070518	First release.
#include "stdafx.h"

#include "CDB482x2.h"
#include <stdio.h>
#include <dos.h>
#include <conio.h>

#define	CDBoxOpenDelay		300	//Delay time for Cash Drawer open

void	CDBoxCMD(int CDBoxCMDValue );

char APName[]=	      "\t\tCash Drawer Testing Program\n"
		"\t===========================================\n" ;

char APHelp[]=	"\n - Pass '1' key for open Cash Drawer 1"
		"\n - Pass '2' key for open Cash Drawer 2"
		"\n - Pass '3' key for open both of Cash Drawer 1 and Cash Drawer 2"
		"\n - Pass '0' key for Exit"
		"\n" ;

void main(void){
	int	PortStatus, OldPortStatus = 0xff;
	char	getkey = 0;

	clrscr();	//clear screen
	printf(APName);
	printf(APHelp);

	printf(	"\nCash Drawer Control Register\t: I/O 0x%X", CDBoxCtlIO);
	printf(	"\nCash Drawer Status Register\t: I/O 0x%X", CDBoxStsIO);

	do{
		PortStatus = (inportb(CDBoxStsIO) & CDBoxStsIOMask);

		if (OldPortStatus != PortStatus){
			OldPortStatus == PortStatus;
			gotoxy (1,12);
			printf ("\n\tCash Drawer 1 Status : ");
			if((PortStatus & CDBox1StsBit) == 0)
				printf(CDBoxStsIs0Str);	// =0
			else
				printf(CDBoxStsIs1Str);	// =1

			printf ("\n\tCash Drawer 2 Status : ");
			if((PortStatus & CDBox2StsBit) == 0)
				printf(CDBoxStsIs0Str);	// =0
			else
				printf(CDBoxStsIs1Str);	// =1
		};

		if (!kbhit()){
			getkey = getch();
			switch (getkey){
				case '1':
					CDBoxCMD( CDBoxCtlCMDOpen1 );
					break;
				case '2':
					CDBoxCMD( CDBoxCtlCMDOpen2 );
					break;
				case '3':
					CDBoxCMD( (CDBoxCtlCMDOpen1 | CDBoxCtlCMDOpen2) );
					break;
			};
			printf( "Input: [%c]        ", getkey);	//DEBUG
		};
	}while (getkey != '0');
}

void	CDBoxCMD(int CDBoxCMDValue ){
	outport(CDBoxCtlIO, CDBoxCMDValue);	//Control value
	delay(CDBoxOpenDelay);			//Delay time for Cash Drawer open
	outport(CDBoxCtlIO, CDBoxCtlCMDAllowClose);	//Allow Close Cash Drawer
}
